$sub
! This is to Hauser's (1984) results
! England, France, and Sweden
! 
$echo
$units 147 $data Freq $read
     730  145   79   13  182   91    2
     237   89   51    3  197  113    4
     252   81  187    8  222  144    8
      66   25   30   99   86   81   40
     731  325  248    5 1506  839   22
     330  187  122    9  802  685   15
      26   18   23   10   96  114   56
     349   56   40    3   80   45    3
     126   64   30    4  103   61    4
     183   72  194   12  128   96    8
     101   77   79  461  156  286   73
     174   93   60    5  339  189    9
     110   79   42    8  235  209   11
      22   26   23   19   68  107   47
     124   27   12    0   38   19    2
      29   10    6    0   16   11    1
      71   11   40    5   64   42    1
      71   44   39   92  132  144   21
     122   40   31    5  188  104    5
      81   28   31    5  159  109    4
      15    3    6    3   33   42    8
$calc %c=7
$calc %r=7
$calc %l=3
$calc column=%gl(%c,1) : row=%gl(%r,%c) : layer=%gl(%l,%c*%r) 
$calc w = 1
$calc w = %if(%eq(row,column), 0, w)
$factor column %c row %r layer %l 
$calc uni=Row*Column
$calc i=Row
$calc j=column
$data fi $read
1  1  1  1  1  1  1
1  2  3  4  5  6  7
1  8  9 10 11 12 13
1 14 15 16 17 18 19
1 20 21 22 23 24 25
1 26 27 28 29 30 31
1 32 33 34 35 36 37
1  1  1  1  1  1  1
1  2  3  4  5  6  7
1  8  9 10 11 12 13
1 14 15 16 17 18 19
1 20 21 22 23 24 25
1 26 27 28 29 30 31
1 32 33 34 35 36 37
1  1  1  1  1  1  1
1  2  3  4  5  6  7
1  8  9 10 11 12 13
1 14 15 16 17 18 19
1 20 21 22 23 24 25
1 26 27 28 29 30 31
1 32 33 34 35 36 37
$calc %a = 37
$fact fi %a
$calc column=%gl(7,1) : row=%gl(7,7) : layer=%gl(3,7*7) 
$calc w = 1
$calc w = %if(%eq(row,column), 0, w)
$calc uni=Row*Column
$calc i=Row
$calc j=column
$calc cross = i + j
$c
$c        setting column = pattern, row = country
$c
  $macro LINP Row + Column + Layer + row*layer + column*layer $endmac  ! LINearPart of the model
  $macro RC !
  $delete m1_ m2_ mu2_ f1_ f2_ f3_ n1_ n2_ nu2_ n3_  df_ beta $
  $warn !
  $calc %z1=%if(%gt(%w,0),%w,10) $
  $calc %h=0 : %d=0  $
  $var 1 df_ $
  $factor r_ %r c_ %c  $
  $calc %z=1 : %z2=%coc  $
  $calc f2_=%yv : n3_=0 $
  $print : 'Deviance     df     Iteration     Change' $
  $while %z frc          $
  $delete df_ f1_ f2_ f3_ m1_ m2_ n1_ n2_ n3_  beta $
  $warn !
  $endmac                !
  !
  $macro frc             !
  $warn                  $
  $out $tran $
  $calc n2_=nu(c_)      $
  $fit #linp+r_.n2_     $
  $var  %pl m1_              $
  $extract %pe $calc m1_=%pe $
  $calc %m=%pl-%r            $
  $calc mu=%gl(%r,1) : mu(mu)=m1_(mu+%m) : m2_=mu(r_) $
  $fit #linp+c_.m2_  $
  $calc %h=%h+1   $
  $var  %pl n1_        $
  $extract %pe $calc n1_=%pe      $
  $calc nu=%gl(%c,1) : %o=%pl-%c :  nu(nu)=n1_(nu+%o) $
  $calc f1_=f2_ : f2_=%fv        $
  $calc f3_=(f2_-f1_)**2 $
  $sort n3_ f3_ $calc %d=n3_(%nu) $
  $calc %d=%sqrt(%d)  $
  $out %z2 $tran i o $
  $use depr $
  $calc %d=%lt(%d,0.001) $
  $switch %d last $
  $calc %e=%ge(%h,%z1)  $
  $switch %e drop   $
  $warn $
  $endmac        !
  !
  $macro depr !
  $calc df_= 3*7*7-1-2-6-6-2*6-2*6 - (%c + %r - 2)
 $
  $print *r %dv,8,3 *i df_,7 *i %h,10  *r %d,15,3 $
  $endmac
  !
  $macro drop   !
  $print  ;'ALGORITHM DID NOT CONVERGE IN '*i %z1,4 ' CYCLES OF ITERATIONS'  !
  $print ' '$
  $calc %z=0 $
  $endmac      !
  !
  $macro last  !
  $warn $
  $print ' '   !
$c    normalization: scores for levels are standardized
$c    with mean of zero and sum of squares of one
$calc %x = %cu(nu)/%c : %y = %sqrt(%cu((nu-%x)**2)) $
  $calc nu2=-(nu-%x)/%y $ 
  $calc mu2=-(mu)*%y $
!  $calc %x=%cu(mu)/%r : mu=mu-%x : %x=%cu(mu**2) : mu=mu/%sqrt(%x) !
!  $calc %y=%cu(nu)/%c : nu=nu-%y : %y=%cu(nu**2) : nu=nu/%sqrt(%y) !
  $print 'ROW SCORES: Country-Specific' !
  $look mu2    !
  $print ' '   !
  $print 'COLUMN SCORES: levels ' !
  $look nu2 !
  $calc mu2_=mu2(r_) : nu2_=nu2(c_) : %h=0  !
  $print  ;'Standard errors and d.f. given below are not valid. '
  $print 'Correct d.f. = '  *i df_,3$
  $print  ;' ' $
  $calc beta=mu2_*nu2_ : %z=0 $fit #linp+beta $dis e !
  $warn !
  $endmac !
  !
$error p
$link l
$yvar freq
$c    including diagonal cells
$c      NA model, conditional independence
$accuracy 10
$fit Row + Column + Layer + row*layer + column*layer 
$disp e
$c      U0 model, uniform association
$fit Row + Column + Layer + row*layer + column*layer + uni
$disp e
$c      U0 model, yamaguch's model
$fit Row + Column + Layer + row*layer + column*layer + uni*layer
$disp e
$c      FI0  model, full interaction
$fit Row + Column + Layer + row*layer + column*layer + row*column 
$disp e
$c      FI1  model, full interaction, Yamaguchi's model
$fit Row + Column + Layer + row*layer + column*layer + row*column +uni.layer
$disp e
$c      level's model, no three-way interaction
$fit Row + Column + Layer + row*layer + column*layer + fi
$disp e
$c      level's model, Yamaguchi's model
$fit Row + Column + Layer + row*layer + column*layer + fi
+uni.layer
$disp e
$c      level's model, three-way interaction
$fit Row + Column + Layer + row*layer + column*layer + fi*layer
$disp e
$calc r_ = layer
$calc c_ = fi
$calc %R = 3
$calc %c = %a
  $delete MU NU 
  $delete MU2 NU2 
  $var %R MU $var %C NU $
  $var %R MU2 $var %C NU2 $
  $calc MU=%gl(%R,1) : NU=%gl(%C,1) ! initial parameter estimates $
$use rc
$c   *************************
$c   Hauser's levels model, six levels
$c   ************************* 
$data fi $read
2 3 4 6 5 6 6
3 3 4 6 4 5 6 
4 4 2 5 5 5 5
6 6 5 1 6 5 2
4 4 5 6 3 4 5
5 4 5 5 3 3 5
6 6 5 3 5 4 1
2 3 4 6 5 6 6
3 3 4 6 4 5 6 
4 4 2 5 5 5 5
6 6 5 1 6 5 2
4 4 5 6 3 4 5
5 4 5 5 3 3 5
6 6 5 3 5 4 1
2 3 4 6 5 6 6
3 3 4 6 4 5 6
4 4 2 5 5 5 5
6 6 5 1 6 5 2
4 4 5 6 3 4 5
5 4 5 5 3 3 5
6 6 5 3 5 4 1
$calc %a = 6
$fact fi %a
$c      level's model, no three-way interaction
$fit Row + Column + Layer + row*layer + column*layer + fi
$disp e
$c      level's model, Yamaguchi's model
$fit Row + Column + Layer + row*layer + column*layer + fi
+uni.layer
$disp e
$c      level's model, three-way interaction
$fit Row + Column + Layer + row*layer + column*layer + fi*layer
$disp e
$calc r_ = layer
$calc c_ = fi
$calc %R = 3
$calc %c = %a
  $delete MU NU 
  $delete MU2 NU2 
  $var %R MU $var %C NU $
  $var %R MU2 $var %C NU2 $
  $calc MU=%gl(%R,1) : NU=%gl(%C,1) ! initial parameter estimates $
$use rc
$weight w
$stop
