$sub
! This is to use Grusky and Hauser's (1984) data
! 15 countries
! deleting Hungary, 3 levels
$echo
$units 135 $data Freq $read
 292  170    29
 290  608    37
  81  171   175
 497  100    12
 300  434     7
 102  101   129
2085 1047    74
 936 2367    57
 592 1255  1587
 233   75    10
 104  291    23
  71  212   320
 465  122    21
 159  258    20
 285  307   333
 239  110    76
  91  292   111
 317  527  3098
7622 2124   379
3495 9072   597
4597 8173 14833
1650  641    34
1618 2692    70
 694 1648   644
3634  850   270
1021 1694   306
1068 1310  1927
 406  235   144
 176  369   183
 315  578  2311
  61   24     7
  37   92    13
  77  148   223
  79   34     2
  55  119     8
  25   48    84
  39   29     2
  24  115    10
  40   66    79
  90   29     5
  72   89    11
  41   47    47
  89   30     0
  81  142     3
  27   48    29
$calc %c=3
$calc %r=3
$calc %l=15
$calc column=%gl(%c,1) : row=%gl(%r,%c) : layer=%gl(%l,%c*%r) 
$calc w = 1
$calc w = %if(%eq(row,column), 0, w)
$factor column %c row %r layer %l 
$calc uni=Row*Column
$calc i=Row
$calc j=column
$data fi $read
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
2 3 3 3 3 3 3 3 1
$calc %a = 3
$fact fi %a
$calc column=%gl(3,1) : row=%gl(3,3) : layer=%gl(15,3*3) 
$calc w = 1
$calc w = %if(%eq(row,column), 0, w)
$factor column 3 row 3 layer 15 
$calc uni=Row*Column
$calc i=Row
$calc j=column
$calc cross = i + j
$c
$c        setting column = pattern, row = country
$c
  $macro LINP Row + Column + Layer + row*layer + column*layer $endmac  ! LINearPart of the model
  $macro RC !
  $delete m1_ m2_ mu2_ f1_ f2_ f3_ n1_ n2_ nu2_ n3_  df_ beta $
  $warn !
  $calc %z1=%if(%gt(%w,0),%w,10) $
  $calc %h=0 : %d=0  $
  $var 1 df_ $
  $factor r_ %r c_ %c  $
  $calc %z=1 : %z2=%coc  $
  $calc f2_=%yv : n3_=0 $
  $print : 'Deviance     df     Iteration     Change' $
  $while %z frc          $
  $delete df_ f1_ f2_ f3_ m1_ m2_ n1_ n2_ n3_  beta $
  $warn !
  $endmac                !
  !
  $macro frc             !
  $warn                  $
  $out $tran $
  $calc n2_=nu(c_)      $
  $fit #linp+r_.n2_     $
  $var  %pl m1_              $
  $extract %pe $calc m1_=%pe $
  $calc %m=%pl-%r            $
  $calc mu=%gl(%r,1) : mu(mu)=m1_(mu+%m) : m2_=mu(r_) $
  $fit #linp+c_.m2_  $
  $calc %h=%h+1   $
  $var  %pl n1_        $
  $extract %pe $calc n1_=%pe      $
  $calc nu=%gl(%c,1) : %o=%pl-%c :  nu(nu)=n1_(nu+%o) $
  $calc f1_=f2_ : f2_=%fv        $
  $calc f3_=(f2_-f1_)**2 $
  $sort n3_ f3_ $calc %d=n3_(%nu) $
  $calc %d=%sqrt(%d)  $
  $out %z2 $tran i o $
  $use depr $
  $calc %d=%lt(%d,0.001) $
  $switch %d last $
  $calc %e=%ge(%h,%z1)  $
  $switch %e drop   $
  $warn $
  $endmac        !
  !
  $macro depr !
  $calc df_= 15*3*3 -1- 14 - 2*2 - 14*2*2 - (%c + %r - 2)
 $
  $print *r %dv,8,3 *i df_,7 *i %h,10  *r %d,15,3 $
  $endmac
  !
  $macro drop   !
  $print  ;'ALGORITHM DID NOT CONVERGE IN '*i %z1,4 ' CYCLES OF ITERATIONS'  !
  $print ' '$
  $calc %z=0 $
  $endmac      !
  !
  $macro last  !
  $warn $
  $print ' '   !
$c    normalization: scores for levels are standardized
$c    with mean of zero and sum of squares of one
$calc %x = %cu(nu)/%c : %y = %sqrt(%cu((nu-%x)**2)) $
  $calc nu2=-(nu-%x)/%y $ 
  $calc mu2=-(mu)*%y $
!  $calc %x=%cu(mu)/%r : mu=mu-%x : %x=%cu(mu**2) : mu=mu/%sqrt(%x) !
!  $calc %y=%cu(nu)/%c : nu=nu-%y : %y=%cu(nu**2) : nu=nu/%sqrt(%y) !
  $print 'ROW SCORES: Country-Specific' !
  $look mu2    !
  $print ' '   !
  $print 'COLUMN SCORES: levels ' !
  $look nu2 !
  $calc mu2_=mu2(r_) : nu2_=nu2(c_) : %h=0  !
  $print  ;'Standard errors and d.f. given below are not valid. '
  $print 'Correct d.f. = '  *i df_,3$
  $print  ;' ' $
  $calc beta=mu2_*nu2_ : %z=0 $fit #linp+beta $dis e !
  $warn !
  $endmac !
  !
$error p
$link l
$yvar freq
$c  including diagonal cells
$c      NA model, conditional independence
$fit Row + Column + Layer + row*layer + column*layer 
$disp e
$c      level's model, no three-way interaction
$fit Row + Column + Layer + row*layer + column*layer + fi
$disp e
$c      level's model, Yamaguchi's
$fit Row + Column + Layer + row*layer + column*layer + fi + uni*layer
$disp e
$c      level's model, three-way interaction
$fit Row + Column + Layer + row*layer + column*layer + fi*layer
$disp e
$calc r_ = layer
$calc c_ = fi
$calc %R = 15
$calc %c = %a
  $delete MU NU 
  $delete MU2 NU2 
  $var %R MU $var %C NU $
  $var %R MU2 $var %C NU2 $
  $calc MU=%gl(%R,1) : NU=%gl(%C,1) ! initial parameter estimates $
$use rc
$stop
