$sub
! This is to replicate Yamaguchi's (1987) results
! 
! 
$units 75 $data Freq $read
      597        1055      394      443       31
      364        1275      274      272       17
      587        1043     1045      951       47
      791        1159     1323     2046       52
      496         666     1031     1632      646
      218         300      171      220        8
      129         474       87      124       11
      254         438      669      703       16
      388         601      932     1789       37
       56          76      125      295      191
      207          86       64       61       13
      101         127       24       30       12
       73          43      122       60       13
       51          35       62       66       11
      206         109      184      253      325
$calc %c=5
$calc %r=5
$calc %l=3
$calc c_=%gl(%c,1) : r_=%gl(%r,%c) : l_=%gl(%l,%c*%r) 
$calc w = 1
$calc w = %if(%eq(r_,c_), 0, w)
$calc cr2 =0
$calc cr2 = %if(%eq(r_,2), 1, cr2)
$calc cr2 = %if(%eq(c_,2), 1, cr2)
$calc cr3 =0
$calc cr3 = %if(%eq(r_,3), 1, cr3)
$calc cr3 = %if(%eq(c_,3), 1, cr3)
$calc cr4 =0
$calc cr4 = %if(%eq(r_,4), 1, cr4)
$calc cr4 = %if(%eq(c_,4), 1, cr4)
$calc cr5 =0
$calc cr5 = %if(%eq(r_,5), 1, cr5)
$calc cr5 = %if(%eq(c_,5), 1, cr5)
$factor c_ %c r_ %r l_ %l 
$calc uni=R_*C_
$calc i=R_
$calc j=c_
$weight w
$error p
$link l
$yvar freq
$c      NA model
$fit R_ + C_ + L_ + r_*l_ + c_*l_ 
$disp e
$c      U0 model
$fit R_ + C_ + L_ + r_*l_ + c_*l_ + uni
$disp e
$data fi $read
1  1  1  1  1
1  1  2  3  4
1  5  1  6  7
1  8  9  1 10 
1 11 12  1  1
1  1  1  1  1
1  1  2  3  4
1  5  1  6  7
1  8  9  1 10 
1 11 12  1  1
1  1  1  1  1
1  1  2  3  4
1  5  1  6  7
1  8  9  1 10 
1 11 12  1  1
$fact fi 12
$calc column=%gl(5,1) : row=%gl(5,5) : layer=%gl(3,5*5) 
$calc w = 1
$calc w = %if(%eq(row,column), 0, w)
$factor column 5 row 5 layer 3 
$calc uni=Row*Column
$calc i=Row
$calc j=column
$calc cross = i + j
$c
$c        setting column = pattern, row = country
$c
  $macro LINP Row + Column + Layer + row*layer + column*layer $endmac  ! LINearPart of the model
  $macro RC !
  $delete m1_ m2_ mu2_ f1_ f2_ f3_ n1_ n2_ nu2_ n3_  df_ beta $
  $warn !
  $calc %z1=%if(%gt(%w,0),%w,10) $
  $calc %h=0 : %d=0  $
  $var 1 df_ $
  $factor r_ %r c_ %c  $
  $calc %z=1 : %z2=%coc  $
  $calc f2_=%yv : n3_=0 $
  $print : 'Deviance     df     Iteration     Change' $
  $while %z frc          $
  $delete df_ f1_ f2_ f3_ m1_ m2_ n1_ n2_ n3_  beta $
  $warn !
  $endmac                !
  !
  $macro frc             !
  $warn                  $
  $out $tran $
  $calc n2_=nu(c_)      $
  $fit #linp+r_.n2_     $
  $var  %pl m1_              $
  $extract %pe $calc m1_=%pe $
  $calc %m=%pl-%r            $
  $calc mu=%gl(%r,1) : mu(mu)=m1_(mu+%m) : m2_=mu(r_) $
  $fit #linp+c_.m2_  $
  $calc %h=%h+1   $
  $var  %pl n1_        $
  $extract %pe $calc n1_=%pe      $
  $calc nu=%gl(%c,1) : %o=%pl-%c :  nu(nu)=n1_(nu+%o) $
  $calc f1_=f2_ : f2_=%fv        $
  $calc f3_=(f2_-f1_)**2 $
  $sort n3_ f3_ $calc %d=n3_(%nu) $
  $calc %d=%sqrt(%d)  $
  $out %z2 $tran i o $
  $use depr $
  $calc %d=%lt(%d,0.001) $
  $switch %d last $
  $calc %e=%ge(%h,%z1)  $
  $switch %e drop   $
  $warn $
  $endmac        !
  !
  $macro depr !
  $calc df_= 3*5*5 - 3*5 - 27 - (%c + %r - 2)
 $
  $print *r %dv,8,3 *i df_,7 *i %h,10  *r %d,15,3 $
  $endmac
  !
  $macro drop   !
  $print  ;'ALGORITHM DID NOT CONVERGE IN '*i %z1,4 ' CYCLES OF ITERATIONS'  !
  $print ' '$
  $calc %z=0 $
  $endmac      !
  !
  $macro last  !
  $warn $
  $print ' '   !
$c    normalization: scores for countries are standardized
$c    with mean of zero and sum of squares of one
$calc %x = %cu(nu)/%c : %y = %sqrt(%cu((nu-%x)**2)) $
  $calc nu2=(nu-%x)/%y $ 
  $calc mu2=(mu)*%y $
!  $calc %x=%cu(mu)/%r : mu=mu-%x : %x=%cu(mu**2) : mu=mu/%sqrt(%x) !
!  $calc %y=%cu(nu)/%c : nu=nu-%y : %y=%cu(nu**2) : nu=nu/%sqrt(%y) !
  $print 'ROW SCORES: Country-Specific' !
  $look mu2    !
  $print ' '   !
  $print 'COLUMN SCORES: levels ' !
  $look nu2 !
  $calc mu2_=mu2(r_) : nu2_=nu2(c_) : %h=0  !
  $print  ;'Standard errors and d.f. given below are not valid. '
  $print 'Correct d.f. = '  *i df_,3$
  $print  ;' ' $
  $calc beta=mu2_*nu2_ : %z=0 $fit #linp+beta $dis e !
  $warn !
  $endmac !
  !
$weight w
$error p
$link l
$yvar freq
$c      NA model
$fit Row + Column + Layer + row*layer + column*layer 
$disp e
$c      FI0  model
$fit Row + Column + Layer + row*layer + column*layer + row*j + row*column 
$disp e
$c      FI0  model, level's approach
$fit Row + Column + Layer + row*layer + column*layer + row*j + fi
$disp e
$c      FI1  model
$fit Row + Column + Layer + row*layer + column*layer + row*j + 
row*column + uni*Layer
$disp e
$c      FI1  model, level's approach
$fit Row + Column + Layer + row*layer + column*layer + row*j + 
fi + uni*Layer
$disp e

$calc r_ = layer
$calc c_ = fi
$calc %R = 3
$calc %c = 12
  $delete MU NU 
  $delete MU2 NU2 
  $var %R MU $var %C NU $
  $var %R MU2 $var %C NU2 $
  $calc MU=%gl(%R,1) : NU=%gl(%C,1) ! initial parameter estimates $
$use rc
$stop

