$sub
! This is to test log-multiplicative model on Yamaguchi's data
! Row and Column Effects Model I
! Note: Macro RC modified
$echo
$units 75 $data Freq $read
        1275      364      274      272       17
        1055      597      394      443       31
        1043      587     1045      951       47
        1159      791     1323     2046       52
         666      496     1031     1632      646
         474      129       87      124       11
         300      218      171      220        8
         438      254      669      703       16
         601      388      932     1789       37
          76       56      125      295      191
         127      101       24       30       12
          86      207       64       61       13
          43       73      122       60       13
          35       51       62       66       11
         109      206      184      253      325
$calc column=%gl(5,1) : row=%gl(5,5) : layer=%gl(3,5*5) 
$calc w = 1
$calc w = %if(%eq(row,column), 0, w)
$calc cr2 =0
$calc cr2 = %if(%eq(row,2), 1, cr2)
$calc cr2 = %if(%eq(column,2), 1, cr2)
$calc cr3 =0
$calc cr3 = %if(%eq(row,3), 1, cr3)
$calc cr3 = %if(%eq(column,3), 1, cr3)
$calc cr4 =0
$calc cr4 = %if(%eq(row,4), 1, cr4)
$calc cr4 = %if(%eq(column,4), 1, cr4)
$calc cr5 =0
$calc cr5 = %if(%eq(row,5), 1, cr5)
$calc cr5 = %if(%eq(column,5), 1, cr5)
$factor column  5 row 5 layer 3 
$calc uni=Row*Column
$calc i=Row
$calc j=column

  $macro LINP Row + Column + Layer + row*layer + column*layer $endmac  ! LINearPart of the model
  !
  $macro RCL ! for (row+column)layer effects model
  $delete m1_ m2_ mu2_ f1_ f2_ f3_ n1_ n2_ nu2_ n3_  df_ beta $
  $delete l1_ l2_ lu2_ $
  $warn !
  $calc %z1=%if(%gt(%w,0),%w,10) $
  $calc %h=0 : %d=0  $
  $var 1 df_ $
  $factor r_ %r c_ %c l_ %l $
  $calc %z=1 : %z2=%coc  $
  $calc f2_=%yv : n3_=0 $
  $print : 'Deviance     df     Iteration     Change' $
  $while %z frc          $
  $delete df_ f1_ f2_ f3_ m1_ m2_ n1_ n2_ n3_  beta $
  $delete l1_ l2_ $
  $warn !
  $endmac                !
  !
  $macro frc             !
  $warn                  $
  $out $tran $
$echo
  $calc n2_=nu(c_)      $
  $calc m2_=mu(r_)      $
  $calc l2_=lu(l_)      $
$calc t1 = l2_*j
$calc t2 = l2_*i
  $fit #linp + r_.t1 + c_.t2  $
!$disp e $
  $var  %pl m1_              $
  $extract %pe $calc m1_=%pe $
  $calc %m=%pl-%r-%c            $
  $calc %n=%pl-%c            $
  $calc mu=%gl(%r,1) : mu(mu)=m1_(mu+%m) : m2_=mu(r_) $
  $calc nu=%gl(%c,1) : nu(nu)=m1_(nu+%n) : n2_=nu(c_) $
$look mu m2_ nu n2_ 
$calc t1 = m2_*j + n2_*i
  $fit #linp+ l_.t1  $
!$disp e $
  $calc %h=%h+1   $
  $var  %pl l1_        $
  $extract %pe $calc l1_=%pe      $
  $calc lu=%gl(%l,1) : %o=%pl-%l :  lu(lu)=l1_(lu+%o) $
$look lu l1_ 
  $calc f1_=f2_ : f2_=%fv        $
  $calc f3_=(f2_-f1_)**2 $
  $sort n3_ f3_ $calc %d=n3_(%nu) $
  $calc %d=%sqrt(%d)  $
  $out %z2 $tran i o $
  $use depr $
  $calc %d=%lt(%d,0.001) $
  $switch %d last $
  $calc %e=%ge(%h,%z1)  $
  $switch %e drop   $
  $warn $
  $endmac        !
  !
  $macro depr !
  $calc df_= 3*5*5 - 3*5 - 27 - (%c + %r - 3 + %l - 1 )
 $
  $print *r %dv,8,3 *i df_,7 *i %h,10  *r %d,15,3 $
  $endmac
  !
  $macro drop   !
  $print  ;'ALGORITHM DID NOT CONVERGE IN '*i %z1,4 ' CYCLES OF ITERATIONS'  !
  $print ' '$
  $calc %z=0 $
  $endmac      !
  !
  $macro last  !
  $warn $
  $print ' '   !
  $print 'Normalization not changed.  Dummy variable coding'!
$c    normalization: scores for countries are standardized
$c    with mean of zero and sum of squares of one
!  $calc %x=%cu(mu)/%r : mu=mu-%x : %x=%cu(mu**2) : mu=mu/%sqrt(%x) !
!  $calc %y=%cu(nu)/%c : nu=nu-%y : %y=%cu(nu**2) : nu=nu/%sqrt(%y) !
!  $calc %z=%cu(lu)/%l : lu=lu-%z  !
  $look mu    !
  $print ' '   !
  $print 'COLUMN SCORES' !
  $look nu !
  $print 'Country-Specific' !
  $look lu   !
  $print ' '   !
  $calc mu2_=mu(r_) : nu2_=nu(c_): lu2_=lu(l_) : %h=0  !
  $print  ;'Standard errors and d.f. given below are not valid. '
  $print 'Correct d.f. = '  *i df_,3$
  $print  ;' ' $
  $calc be1=mu2_*j*lu2_ : $calc be2=nu2_*i*lu2_ : %z=0 
$fit #linp+be1 + be2 
$dis e !
  $warn !
  $endmac !
  !
$weight w
$error p
$link l
$yvar freq
$c      NA model
$fit Row + Column + Layer + row*layer + column*layer 
$disp e
$c       ********** row and column effects Models *****
$c      R + C0  model
$fit Row + Column + Layer + row*layer + column*layer + row*j + column *i 
$disp e
$c      R + C1  model
$fit Row + Column + Layer + row*layer + column*layer + row*j 
+ column *i + uni*Layer
$disp e
$c   ********Input: natural codings.
$c
$calc c_ = column
$calc %C = 5
$calc r_ = row
$calc %r = 5
$calc l_ = layer
$calc %l = 3
  $delete MU NU lu
  $delete MU2 NU2 lu2
  $var %R MU $var %C NU $var %l lu $
  $var %R MU2 $var %C NU2 $var %l lU2 $
  $calc MU=%gl(%R,1) : NU=%gl(%C,1) : lu=%gl(%l,1) ! initial parameter estimates $
$use rcl
$stop

